function D = distanceMatrix(X, Y)
% D = DISTANCEMATRIX(X, Y) computes the distance matrix D_ij = ||X_i - Y_j||

% Try to use built-in distance matrix
if exist('pdist2', 'file')
    D = pdist2(X, Y);
else
    D = sqrt(bsxfun(@plus, sum(X .^ 2, 2), sum(Y .^ 2, 2)') - 2 * X * Y');
end

end